# grdtrack

Sample one or more grids at specified locations

## Synopsis

gmt grdtrack [ table ] -G grd1 -G grd2 … [ -A[f|p|m|r|R][+l] ] [ -C length/ds[/spacing][+a|v][d|f value][l|r] ] [ -D dfile ] [ -E line ] [ -F[+b][+n][+r][+z z0] ] [ -N ] [ -R region ] [ -S method/modifiers ] [ -S[a|l|L|m|p|u|U][+a][+c][+d][+r][+s[file] ] [ -T[radius][+e|p]] [ -V[level] ] [ -Z ] [ -a flags ] [ -b binary ] [ -d nodata[+c col] ] [ -e regexp ] [ -f flags ] [ -g gaps ] [ -h headers ] [ -i flags ] [ -j flags ] [ -n flags ] [ -o flags ] [ -q flags ] [ -s flags ] [ -w flags ] [ -:[i|o] ] [ --PAR=value ]

Note: No space is allowed between the option flag and the associated arguments.

## Description

grdtrack reads one or more grid files (or a Sandwell/Smith IMG files) and a table (from file or standard input; but see -E for exception) with (x, y) [or (lon, lat)] positions in the first two columns (more columns may be present). It interpolates the grid(s) at the positions in the table and writes out the table with the interpolated values added as (one or more) new columns. Alternatively (-C), the input is considered to be line-segments and we create orthogonal cross-profiles at each data point or with an equidistant separation and sample the grid(s) along these profiles. A bicubic [Default], bilinear, B-spline or nearest-neighbor (see -n) interpolation is used, requiring boundary conditions at the limits of the region (see -n; Default uses “natural” conditions (second partial derivative normal to edge is zero) unless the grid is automatically recognized as periodic.)

## Required Arguments

table

  This is an ASCII (or binary, see -bi) file where the first 2 columns hold the (x, y) positions where the user wants to sample the 2-D data set. If no tables are given then we read from standard input. If -E is set then no input table is read since we will create one from the given -E parameters.

-G gridfile

  gridfile is a 2-D binary grid file with the function f(x, y). If the specified grid is in Sandwell/Smith Mercator format you must append a comma-separated list of arguments that includes a scale to multiply the data (usually 1 or 0.1), the mode which stand for the following: (0) Img files with no constraint code, returns data at all points, (1) Img file with constraints coded, return data at all points, (2) Img file with constraints coded, return data only at constrained points and NaN elsewhere, and (3) Img file with constraints coded, return 1 at constraints and 0 elsewhere, and optionally the max latitude in the IMG file [80.738]. You may repeat -G as many times as you have grids you wish to sample. Alternatively, use -G+l list to pass a file whose first word in the trailing text record will be extracted as the file names. The grids are sampled and results are output in the order given. (See Grid File Formats). Note: If gridfile is a remote global grid and no registration is specified then grdtrack will default to gridline registration (instead of the default pixel registration) to ensure all input points are inside the grid.

## Optional Arguments

-A[f|p|m|r|R][+l]

  For track resampling (if -C or -E are set) we can select how this is to be performed. Append f to keep original points, but add intermediate points if needed [Default], m as f, but first follow meridian (along y) then parallel (along x), p as f, but first follow parallel (along y) then meridian (along x), r to resample at equidistant locations; input points are not necessarily included in the output, and R as r, but adjust given spacing to fit the track length exactly. Finally, append +l if geographic distances should be measured along rhumb lines (loxodromes) instead of great circles. Ignored unless -C is used.

-C length/ds[/spacing][+a|v][d|f value][l|r]

  Use input line segments to create an equidistant and (optionally) equally-spaced set of crossing profiles along which we sample the grid(s). Specify two length scales that control how the sampling is done: length sets the full length of each cross-profile, while ds is the sampling spacing along each cross-profile. Optionally, append /spacing for an equidistant spacing between cross-profiles [Default erects cross-profiles at the input coordinates]; see -A for how resampling the input track is controlled. By default, all cross-profiles have the same direction (left to right as we look in the direction of the input line segment). Append +a to alternate the direction of cross-profiles, or +v to enforce either a “west-to-east” or “south-to-north” view. By default the entire profiles are output. Choose to only output the left or right halves of the profiles by appending +l or +r, respectively. Append suitable units to length; it sets the unit used for ds [and spacing] (See Units below). The default unit for geographic grids is meter while Cartesian grids implies the user unit. The output columns will be lon, lat, dist, azimuth, z1, z2, …, zn (The zi are the sampled values for each of the n grids). Use +d to change the profiles from being orthogonal to the line by the given deviation [0]. Looking in the direction of the line, a positive deviation will rotate the crosslines clockwise and a negative one will rotate them counter-clockwise. Finally, you can use +f to set a fixed azimuth for all profiles. Note: If -C is set and spacing is given then that sampling scheme overrules any modifier set in -E.

-D dfile

  In concert with -C we can save the (possibly resampled) original lines to the file dfile [Default only saves the cross-profiles]. The columns will be lon, lat, dist, azimuth, z1, z2, … (sampled value for each grid).

-E table|origin|line[,line,…][+a az][+c][+d][+g][+i inc][+l length][+n np][+o az][+p][+r radius][+x]

  Specify one or more profiles along which we will sample the grid (or cube). There are several way to supply or create the profiles:

  - Give your custom profiles via a table containing lon lat points.

  - Given an origin (and azimuth and length and relevant modifiers below).

  - Give one or more lines. The format of each line is start/stop, where start or stop are either lon/lat (x/y for Cartesian data) or a 2-character key that uses the text-style justification format to specify a point on the map as [LCR][BMT]. In addition to line coordinates, you can use Z-, Z+ to mean the global minimum and maximum locations in the grid (only available if a single input grid is given) or top layer in a cube (only for doc:grdinterpolate).

  Choose among several modifiers to create profiles:

  - +a - Set the azimuth of a profile of given length (see +l) starting at the given origin.

  - +c - Connect multiple profile segments with shared joints into a single segment.

  - +d - Compute the along-track distances of the profiles.

  - +g - Report degrees of longitude or latitude instead of great circle distances starting at zero [Default].

  - +i - Append inc to set the sampling interval; if not given then we default to half the minimum grid interval.

  - +l - Append the total length of the profile if +a or +o are used with an origin.

  - +n - Append the desired number of points along profile (which determines the sampling interval).

  - +o - Like +a, but centers the profile on the given origin in the azimuth direction.

  - +p - Force sampling along the parallel if your line starts and ends at the same latitude [Great circle].

  - +r - Append radius for circular sampling along small circle of given radius centered on the origin. Requires either +n or +i.

  - +x - Compute distances along a loxodrome (i.e., rhumbline) instead of along the great circle.

  Notes: (1) Only one distance unit can be chosen. Giving different units will result in an error. If no units are specified we default to great circle distances in km (if geographic). (2) If working with geographic data you can use -j to control the distance calculation mode [Great Circle].

-F[+b][+n][+r][+z z0]

  Find critical points along each cross-profile as a function of along-track distance. Requires -C and a single input grid (z). We examine each cross-profile generated and report (dist, lonc, latc, distc, azimuthc, zc) at the center peak of maximum z value, (lonl, latl, distl) and (lonr, latr, distr) at the first and last non-NaN point whose z-value exceeds z0, respectively, and the width based on the two extreme points found. Here, dist is the distance along the original input trackfile and the other 12 output columns are a function of that distance. When searching for the center peak and the extreme first and last values that exceed the threshold we assume the profile is positive up. If we instead are looking for a trough then you must use +n to temporarily flip the profile to positive (internally). The threshold z0 value is always given as >= 0; use +z to change it [0]. Alternatively, use +b to determine the balance point and standard deviation of the profile; this is the weighted mean and weighted standard deviation of the distances, with z acting as the weight. Finally, use +r to obtain the weighted rms about the cross-track center (distc == 0). Note: We round the exact results to the nearest distance nodes along the cross-profiles. We write 13 output columns per track: dist, lonc, latc, distc, azimuthc, zc, lonl, latl, distl, lonr, latr, distr, width.

-N

  Do not skip points that fall outside the domain of the grid(s) [Default only output points within grid domain].

-R xmin/xmax/ymin/ymax[+r][+u unit]

  Specify the region of interest. (See full description) (See cookbook information).

-S[a|l|L|m|p|u|U][+a][+c][+d][+r][+s[file]

  In conjunction with -C, compute a single stacked profile from all profiles across each segment. Append a method for how stacking should be computed: a = mean (average), m = median, p = mode (maximum likelihood), l = lower, L = lower but only consider positive values, u = upper, U = upper but only consider negative values [a]. The modifiers control the output; choose one or more among these choices: +a : Append stacked values to all cross-profiles. +d : Append stack deviations to all cross-profiles. +r : Append data residuals (data - stack) to all cross-profiles. +s[file] : Save stacked profile to file [grdtrack_stacked_profile.txt]. +c fact : Compute uncertainty envelope on stacked profile as ±fact *deviation [2]. Notes: (1) Deviations depend on method and are standard deviation (a), L1 scale, i.e., 1.4826 * median absolute deviation (MAD) (for m and p), or half-range (upper-lower)/2 (for l, L, u and U). (2) The stacked profile file contains a leading column plus groups of 4-6 columns, with one group for each sampled grid. The leading column holds cross distance, while the first four columns in a group hold stacked value, deviation, min value, and max value, respectively. If method is one of a|m|p then we also write two additional columns: the lower and upper confidence bounds (see +c). When one or more of +a, +d, and +r are used then we also append the stacking results to the end of each row, for all cross-profiles. The order is always stacked value (+a), followed by deviations (+d) and finally residuals (+r); actual output depends on which of these modifiers were actually used. When more than one grid is sampled this sequence of 1-3 columns is repeated for each grid. (3) See Illustration Gallery 33 for an example of grid profile stacking.

-T[radius][+e|p]

  To be used with normal grid sampling, and limited to a single, non-IMG grid. If the nearest node to the input point is NaN, search outwards until we find the nearest non-NaN node and report that value instead. Optionally specify a search radius which limits the consideration to points within this distance from the input point. To report the location of the nearest node and its distance from the input point, append +e. The default unit for geographic grid distances is spherical degrees. Use radius to change the unit and give radius = 0 if you do not want to limit the radius search. To instead replace the input point with the coordinates of the nearest node, append +p.

-V[level]

  Select verbosity level [w]. (See full description) (See cookbook information).

-Z

  Only write out the sampled z-values [Default writes all columns]. Note: If used in conjunction with -s then the default column becomes 0 instead of 2. If specifying specific columns in -s then start numbering the z-columns from 0 instead of 2.

-a[[col=]name[,…]] (more …)

  Set aspatial column associations col=name.

-bi record[+b|l] (more …)

  Select native binary format for primary table input. [Default is 2 input columns].

-bo record[+b|l] (more …)

  Select native binary format for table output. [Default is one more than input].

-d[i|o][+c col]nodata (more …)

  Replace input columns that equal nodata with NaN and do the reverse on output.

-e[~]“pattern” | -e[~]/regexp/[i] (more …)

  Only accept data records that match the given pattern.

-f[i|o]colinfo (more …)

  Specify data types of input and/or output columns.

-g x|y|z|d|X|Y|D gap[u][+a][+c col][+n|p] (more …)

  Determine data gaps and line breaks.

-h[i|o][n][+c][+d][+m segheader][+r remark][+t title] (more …)

  Skip or produce header record(s).

-i cols[+l][+d divisor][+s scale|d|k][+o offset][,…][,t[word]] (more …)

  Select input columns and transformations (0 is first column, t is trailing text, append word to read one word only).

-je|f|g (more …)

  Determine how spherical distances or coordinate transformations are calculated.

-n[b|c|l|n][+a][+b BC][+c][+t threshold] (more …)

  Select interpolation mode for grids.

-o cols[+l][+d divisor][+s scale|d|k][+o offset][,…][,t[word]] (more …)

  Select output columns and transformations (0 is first column, t is trailing text, append word to write one word only).

-q[i|o][~]rows|limits[+c col][+a|t|s] (more …)

  Select input or output rows or data limit(s) [all].

-s[cols][+a][+r] (more …)

  Set handling of NaN records for output.

-wy|a|w|d|h|m|s|c period[/phase][+c col] (more …)

  Convert an input coordinate to a cyclical coordinate.

-:

  Toggles between (longitude,latitude) and (latitude,longitude) input/output. [Default is (longitude,latitude)].

-^ or just -

  Print a short message about the syntax of the command, then exit (Note: on Windows just use -).

-+ or just +

  Print an extensive usage (help) message, including the explanation of any module-specific option (but not the GMT common options), then exit.

-? or no arguments

  Print a complete usage (help) message, including the explanation of all options, then exit.

--PAR=value

  Temporarily override a GMT default setting; repeatable. See gmt.conf for parameters.

## Units

For map distance unit, append unit d for arc degree, m for arc minute, and s for arc second, or e for meter [Default unless stated otherwise], f for foot, k for km, M for statute mile, n for nautical mile, and u for US survey foot. By default we compute such distances using a spherical approximation with great circles (-jg) using the authalic radius (see PROJ_MEAN_RADIUS). You can use -jf to perform “Flat Earth” calculations (quicker but less accurate) or -je to perform exact geodesic calculations (slower but more accurate; see PROJ_GEODESIC for method used).

## ASCII Format Precision

The ASCII output formats of numerical data are controlled by parameters in your gmt.conf file. Longitude and latitude are formatted according to FORMAT_GEO_OUT, absolute time is under the control of FORMAT_DATE_OUT and FORMAT_CLOCK_OUT, whereas general floating point values are formatted according to FORMAT_FLOAT_OUT. Be aware that the format in effect can lead to loss of precision in ASCII output, which can lead to various problems downstream. If you find the output is not written with enough precision, consider switching to binary output (-bo if available) or specify more decimals using the FORMAT_FLOAT_OUT setting.

## Consequences of grid resampling

Resample or sampling of grids will use various algorithms (see -n) that may lead to possible distortions or unexpected results in the resampled values. One expected effect of resampling with splines is the tendency for the new resampled values to slightly exceed the global min/max limits of the original grid. If this is unacceptable, you can impose clipping of the resampled values values so they do not exceed the input min/max values by adding +c to your -n option.

## Hints

If an interpolation point is not on a node of the input grid, then a NaN at any node in the neighborhood surrounding the point will yield an interpolated NaN. Bicubic interpolation [default] yields continuous first derivatives but requires a neighborhood of 4 nodes by 4 nodes. Bilinear interpolation [-n] uses only a 2 by 2 neighborhood, but yields only zeroth-order continuity. Use bicubic when smoothness is important. Use bilinear to minimize the propagation of NaNs, or lower threshold.

## Examples

Note: Below are some examples of valid syntax for this module. The examples that use remote files (file names starting with `@`) can be cut and pasted into your terminal for testing. Other commands requiring input files are just dummy examples of the types of uses that are common but cannot be run verbatim as written.

To extract a profile along a great circle between (0,0) to (20,20) from the remote grid earth_relief_05m, and only write out (dist, topo) records, try:

    gmt grdtrack -G@earth_relief_05m -R0/20/0/20 -EBL/TR+d -o3,2 > profile.txt

To sample the file hawaii_topo.nc along the SEASAT track track_4.xyg (An ASCII table containing longitude, latitude, and SEASAT-derived gravity, preceded by one header record):

    gmt grdtrack track_4.xyg -Ghawaii_topo.nc -h > track_4.xygt

To sample the Sandwell/Smith IMG format file topo.8.2.img (2 minute predicted bathymetry on a Mercator grid) and the Muller et al age grid age.3.2.nc along the (lon, lat) coordinates given in the file cruise_track.xy, try:

    gmt grdtrack cruise_track.xy -Gtopo.8.2.img,1,1 -Gage.3.2.nc > depths-age.txt

To sample the Sandwell/Smith IMG format file grav.18.1.img (1 minute free-air anomalies on a Mercator grid) along 100-km-long cross-profiles that are orthogonal to the line segment given in the file track.xy, erecting cross-profiles every 25 km and sampling the grid every 3 km, try

    gmt grdtrack track.xy -Ggrav.18.1.img,0.1,1 -C100k/3/25 -Ar > xprofiles.txt

The same thing, but now determining the central anomaly location along track, with a threshold of 25 mGal, try:

    gmt grdtrack track.xy -Ggrav.18.1.img,0.1,1 -C100k/3/25 -F+z25 > locations.txt

To sample the grid data.nc along a line from the lower left to the upper right corner, using a grid spacing of 1 km on the geodesic, and output distances as well, try:

    gmt grdtrack -ELB/RT+i1k+d -Gdata.nc -je > profiles.txt

## See Also

gmt, gmtconvert, text, sample1d, surface